<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from builder.texi on 28 April 1999 -->

<TITLE>The Builder Library - Creating SUIF code</TITLE>
<link href="builder_28.html" rel=Next>
<link href="builder_26.html" rel=Previous>
<link href="builder_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_26.html">previous</A>, <A HREF="builder_28.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC58" HREF="builder_toc.html#TOC58">Creating SUIF Code</A></H1>
<P>
<A NAME="IDX142"></A>
<A NAME="IDX143"></A>
In the builder type system (See section <A HREF="builder_5.html#SEC12">Types</A>) the SUIF structure
<CODE>type_node</CODE> is directly created by <CODE>parse_type()</CODE>. Also in
variable creation (See section <A HREF="builder_10.html#SEC25">Creating and Using Variables</A>) the builder function
<CODE>new_sym()</CODE> will create the corresponding SUIF structure
<CODE>var_sym</CODE>. But for larger structures such as expression trees and
control flow, the builder does not create any SUIF, but keeps the
information in an internal builder structure. An explicit command is
needed to create SUIF out of builder structures. The builder
commands to create SUIF are
<DL COMPACT>

<DT><CODE>make_instruction()</CODE>
<DD>
Creates an expression tree.

<DT><CODE>make_tree_node()</CODE>
<DD>
Creates a tree node.

<DT><CODE>make_tree_node_list()</CODE>
<DD>
Creates a list of tree nodes.
</DL>
<P>
<A NAME="IDX144"></A>
<A NAME="IDX145"></A>
<A NAME="IDX146"></A>

</P>
<P>
Note that these commands cannot be applied to all builder structures. From
an expression tree builder structure, an <CODE>instruction</CODE>,
<CODE>tree_node</CODE> or <CODE>tree_node_list</CODE> can be created.  But it is
illegal to make an <CODE>instruction</CODE> from a builder control-flow
structure. See section <A HREF="builder_40.html#SEC73">Generating SUIF Code</A> for a detailed description of
available builder commands.

</P>

<UL>
<LI><A HREF="builder_28.html#SEC59">Example of creating SUIF</A>: Example
<LI><A HREF="builder_29.html#SEC60">Destination of results</A>: Where the results go
</UL>

<P><HR><P>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_26.html">previous</A>, <A HREF="builder_28.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
</BODY>
</HTML>
